#ifndef CMAZECELL_H
#define CMAZECELL_H

#include <SDL/SDL.h>

// #include "cMazeField.h"

class cMazeField;

class cMazeCell {
public:
    int render(SDL_Surface* dst, cMazeField* container);

    int sTop(bool p);
    int sLeft(bool p);
    int visit();
    int use();
    int unuse();

    bool gTop();
    bool gLeft();
    bool gVisit();
    bool gVisitD();

    cMazeCell(int x, int y, int size);
    ~cMazeCell();

    int sMom(int x, int y);
    int gMomX();
    int gMomY();
    int visitD();
    int unvisitD();

private:
    bool top, left; // Walls
    bool visited; // Maze algorithm
    bool current;

    bool visitedD; // Dijkstra's
    int momX;
    int momY;

    int x, y; // For rendering
} ;

const bool C_WALL = true;
const bool C_NOWALL = false;

const int C_SIZE = 10;
const int C_BORDER = 2;

#endif
