// Includes I didn't make myself
#include <SDL/SDL.h>

// Includes I did make myself
#include "gamestate.h"
#include "gamestates.h"
#include "globals.h"

int cGameState::input() {
    while (SDL_PollEvent(&event)) {
        if (event.type == SDL_QUIT) {
            gameMan->setNextState(STATE_EXIT);
        }
    }

    this->mouseState = SDL_GetMouseState(&this->mX, &this->mY);
    this->keyState = SDL_GetKeyState(NULL);

    return 0;
}

// ----------------------------------------------------------------------------------------------

cGameMan::cGameMan(int startState) {
    switch (startState) {
        case STATE_INTRO:
                this->currState = new gsIntro();
            break;
        case STATE_MENU:
            this->currState = new gsMenu();
            break;
        case STATE_PARAMS:
            this->currState = new gsParams();
            break;
        case STATE_MAZE:
            this->currState = new gsMaze();
            break;
        case STATE_HOWTO:
            this->currState = new gsHowTo();
            break;
        case STATE_ABOUT:
            this->currState = new gsAbout();
            break;
    }

    this->stateID = startState;
    this->nextState = STATE_NULL;

    params = new int[3];
    params[0] = 0;
    params[1] = 0;
    params[2] = 0;
}

cGameMan::~cGameMan() {

}

int cGameMan::setNextState(int targetState) {
    if (this->nextState != STATE_EXIT) {
        this->nextState = targetState;
    }

    return 0;
}

int cGameMan::changeState() {
    if (this->nextState != STATE_NULL) {
        if (this->nextState != STATE_EXIT) {
            delete this->currState;

            switch (this->nextState) {
                case STATE_INTRO:
                    this->currState = new gsIntro();
                    break;
                case STATE_MENU:
                    this->currState = new gsMenu();
                    break;
                case STATE_PARAMS:
                    this->currState = new gsParams();
                    break;
                case STATE_MAZE:
                    this->currState = new gsMaze();
                    break;
                case STATE_HOWTO:
                    this->currState = new gsHowTo();
                    break;
                case STATE_ABOUT:
                    this->currState = new gsAbout();
                    break;
                default:
                    this->currState = new gsIntro();
                    break;
            }

            this->stateID = this->nextState;
            this->nextState = STATE_NULL;
        } else {
            this->stateID = STATE_EXIT;
        }
    }

    return 0;
}

int cGameMan::getState() {
    return this->stateID;
}
