/*
    STATE_NULL,
    STATE_INTRO,
    STATE_MENU,
    STATE_PARAMS,
    STATE_MAZE,
    STATE_HOWTO,
    STATE_ABOUT,
    STATE_EXIT
*/

#include "button.h"
#include "checkboxes.h"
#include "cMaze.h"
#include "gamestate.h"

#ifndef GAMESTATES_H
#define GAMESTATES_H

class gsIntro : public cGameState {
private:
    cButton* testButton;

public:
    int logic();
    int render();

    gsIntro();
    ~gsIntro();
} ;

class gsMenu : public cGameState {
private:
    cButton* bGenerate;
    cButton* bHowTo;
    cButton* bAbout;
    cButton* bExit;

    SDL_Surface* header;

public:
    int logic();
    int render();

    gsMenu();
    ~gsMenu();
} ;

class gsParams : public cGameState {
private:
    cButton* bBack;
    cButton* bGenerate;

    cCheckboxes* algorithm;
    cCheckboxes* size;
    cCheckboxes* speed;

    SDL_Surface* instructions;

    SDL_Surface* header; // /

    SDL_Surface* algorithmHeader; // /
    SDL_Surface* algorithmMuur; // /
    SDL_Surface* algorithmHunt; //
    SDL_Surface* algorithmBinair; //
    SDL_Surface* algorithmPrims; //

    SDL_Surface* sizeHeader; // /
    SDL_Surface* sizeSmall; // /
    SDL_Surface* sizeMiddle; //
    SDL_Surface* sizeBig; //

    SDL_Surface* speedHeader; // /
    SDL_Surface* speedSlow; // /
    SDL_Surface* speedMiddle; //
    SDL_Surface* speedFast; //

    SDL_Surface* zero;
    SDL_Surface* one;
    SDL_Surface* two;
    SDL_Surface* three;
    SDL_Surface* four;

    int algorithmP;
    int sizeP;
    int speedP;

public:
    int logic();
    int render();

    gsParams();
    ~gsParams();
} ;

class gsMaze : public cGameState {
private:
    cButton* bBack;
    cMaze* maze;
    cCheckboxes* speed;
    cCheckboxes* path;

    SDL_Surface* tagPause;
    SDL_Surface* tagFast;
    SDL_Surface* tagSpeed;
    SDL_Surface* tagPath;

    int tempo;
    int startFrame;

public:
    int logic();
    int render();

    gsMaze();
    ~gsMaze();
} ;

class gsHowTo : public cGameState {
private:
    cButton* bBack;

public:
    int logic();
    int render();

    gsHowTo();
    ~gsHowTo();
} ;

class gsAbout : public cGameState {
private:
    cButton* bBack;

public:
    int logic();
    int render();

    gsAbout();
    ~gsAbout();
} ;

#endif
