#ifndef CMAZEFIELD_H
#define CMAZEFIELD_H

#include <SDL/SDL.h>
#include <vector>

// #include "cMazeCell.h"

class cMazeCell;

class cMazeField {
public:
    SDL_Surface* render();

    int visit(int x, int y);
    int visitD(int x, int y);
    int sWall(int x, int y, int pos, int p);
    int use(int x, int y);
    int useRow(int rowN);
    int unuse();
    int connect(int x1, int y1, int x2, int y2, bool p);

    bool isVisited(int x, int y);

    bool gWall(int x, int y, int pos);
    bool hasUnvisitedN(int x, int y); // has unvisited neighbours
    int rowHasUnvisited(int rowN);
    int gSize();

    cMazeField(int fSize);
    ~cMazeField();

private:
    int size; // square field
    SDL_Surface* mazeSurface;

    std::vector< std::vector<cMazeCell> > maze;
} ;

const int CELL_TOP = 1;
const int CELL_RIGHT = 2;
const int CELL_BOTTOM = 3;
const int CELL_LEFT = 4;

#endif
