#include <SDL/SDL.h>

#include "button.h"
#include "functions.h"
#include "gamestate.h"
#include "gamestates.h"
#include "globals.h"

int gsIntro::logic() {
    testButton->logic(mX, mY, mouseState);

    if (testButton->getButtonState() == B_CLICK) {
        gameMan->setNextState(STATE_MENU);
    }

    maze->logic(7, true);

    return 0;
}

int gsIntro::render() {
    SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 255, 255, 255));

    testButton->render();

    maze->render(true);

    SDL_Flip(screen);

    return 0;
}

gsIntro::gsIntro() {
    testButton = new cButton(">> Start Maze+ <<", 70, -5, false, fHeader, B_VISIBLE, B_STANDARD);

    maze = new cPrims(25);
}

gsIntro::~gsIntro() {
    delete testButton;

    delete maze;
}
